/* The cabbage/wolf/goat problem.
   A farmer has to bring a cabbage, a wolf, and a goat from the left
   bank of the river to the right bank.  If he leaves the cabbage and
   goat (resp. the wolf and goat) unattended on either bank, then the
   goat eats the cabbage (resp. the wolf eats the goat), and he
   loses.  He can carry a single item from one bank to the next.
*/
  
bit c = 1; /* cabbage on the left bank */
bit w = 1; /* wolf on the left bank    */
bit g = 1; /* goat on the left bank    */
bit f = 1; /* farmer on the left bank  */

active proctype Cross ()
{
  /* non-deterministic choice */
  do
  :: (f==c)                 -> d_step { f = !f; c = !c; }
  :: (f==g)                 -> d_step { f = !f; g = !g; }
  :: (f==w)                 -> d_step { f = !f; w = !w; }
  :: skip                   -> d_step { f = !f; }
  od;
}
